# Annotation Glossary

### A

allow-none

  NULL is OK, both for passing and for returning.

array

  Parameter points to an array of items.

### C

closure

  This parameter is a 'user_data', for callbacks; many bindings can pass NULL here.

constructor

  This symbol is a constructor, not a static method.

### E

element-type

  Generics and defining elements of containers and arrays.

### I

inout

  Parameter for input and for returning results. Default is transfer full.

### M

method

  This is a method

### N

nullable

  NULL may be passed as the value in, out, in-out; or as a return value.

### O

optional

  NULL may be passed instead of a pointer to a location.

out

  Parameter for returning results. Default is transfer full.

out caller-allocates

  Out parameter, where caller must allocate storage.

### S

scope async

  The callback is valid until first called.

scope call

  The callback is valid only during the call to the method.

skip

  Exposed in C code, not necessarily available in other languages.

Stable

  The intention of a Stable interface is to enable arbitrary third parties to develop applications to these interfaces, release them, and have confidence that they will run on all minor releases of the product (after the one in which the interface was introduced, and within the same major release). Even at a major release, incompatible changes are expected to be rare, and to have strong justifications.

### T

transfer full

  Free data after the code is done.

transfer none

  Don't free data after the code is done.

type

  Override the parsed C type with given type.